%{!?tcl_version: %global tcl_version %((echo '8.5'; echo 'puts $tcl_version' | tclsh 2>/dev/null) | tail -1)}
%{!?tcl_sitearch: %global tcl_sitearch %{_libdir}/tcl%{tcl_version}}

%global pkgname tclreadline

Summary:        GNU Readline extension for Tcl/Tk
Name:           tcl-tclreadline
Version:        2.1.0
Release:    2%{?dist}
License:        BSD
URL:            http://tclreadline.sourceforge.net/
Source0:        https://downloads.sourceforge.net/sourceforge/%{pkgname}/%{pkgname}-%{version}.tar.gz
Source1:        https://sourceforge.net/p/tclreadline/git/ci/master/tree/sample.tclshrc?format=raw#/sample.tclshrc
Patch0:         tcl-tclreadline-2.1.0-libdir.patch
Patch1:         tcl-tclreadline-2.1.0-syntax.patch
Patch2:         tcl-tclreadline-2.1.0-man-page.patch
Patch3:         tcl-tclreadline-2.1.0-rl_completion.patch
Patch4:         tcl-tclreadline-2.1.0-prompt2.patch
Patch5:         tcl-tclreadline-2.1.0-memuse.patch
Patch6:         tcl-tclreadline-ding.patch
Patch7:         tcl-tclreadline-configure-fclose.patch
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  tcl-devel
BuildRequires:  readline-devel
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
Requires:       tcl(abi) = %{tcl_version}
Provides:       %{pkgname} = %{version}-%{release}
Provides:       %{pkgname} = %{version}-%{release}

%description
The tclreadline package makes the GNU Readline library available
for interactive tcl shells. This includes history expansion and
file/command completion. Command completion for all tcl/tk commands
is provided and command completion for user defined commands can
be easily added. Tclreadline can also be used for tcl scripts which
want to use a shell like input interface.

%package devel
Summary:        Development files for the tclreadline library
Requires:       %{name} = %{version}-%{release}

%description devel
The tclreadline-devel package includes the header file and library
necessary for developing programs which use the tclreadline library.

%prep
%setup -q -n %{pkgname}-%{version}
%patch0 -p1 -b .libdir
%patch1 -p1 -b .syntax
%patch2 -p1 -b .man-page
%patch3 -p1 -b .rl_completion
%patch4 -p1 -b .prompt2
%patch5 -p1 -b .memuse
%patch6 -p1 -b .ding
%patch7 -p1 -b .configure-fclose
autoreconf -f -i

cp -pf %{SOURCE1} .

%build
%configure --libdir=%{tcl_sitearch}/%{pkgname}%{version} --with-tcl=%{_libdir}

sed -e 's@ -shared @ -Wl,--as-needed\0@g' -i libtool

%make_build

%install
%make_install

mv -f %{buildroot}{%{tcl_sitearch}/%{pkgname}%{version},%{_libdir}}/lib%{pkgname}-%{version}.so
rm -f %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/lib%{pkgname}.so
ln -s ../../lib%{pkgname}-%{version}.so %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/lib%{pkgname}.so
ln -s lib%{pkgname}-%{version}.so %{buildroot}%{_libdir}/lib%{pkgname}.so

for file in tclreadlineSetup.tcl tclreadlineInit.tcl pkgIndex.tcl; do
  sed -e '1d' %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/$file > \
    %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/$file.new
  touch -c -r %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/$file{,.new}
  mv -f %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/$file{.new,}
done

rm -f %{buildroot}%{tcl_sitearch}/%{pkgname}%{version}/*.{a,la}


%files
%license COPYING
%doc AUTHORS ChangeLog README sample.tclshrc
%{_libdir}/lib%{pkgname}-%{version}.so
%{tcl_sitearch}/%{pkgname}%{version}
%{_mandir}/mann/%{pkgname}.n*

%files devel
%{_libdir}/lib%{pkgname}.so
%{_includedir}/%{pkgname}.h

%changelog
* Fri Jun 13 2025 bbrucezhang <bbrucezhang@tencent.com> - 2.1.0-2
- Rebuilt for loongarch64

* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.1.0-1
- initial build
